Index: examples/evaluator_rt1_typed/ISI_ID.pem
===================================================================
--- examples/evaluator_rt1_typed/ISI_ID.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/ISI_ID.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,19 +1,19 @@
 -----BEGIN CERTIFICATE-----
-MIIDATCCAemgAwIBAgIIZvEQb8f2kLEwDQYJKoZIhvcNAQEFBQAwDjEMMAoGA1UE
-AxMDSVNJMB4XDTEyMDExNzIyMjQzNVoXDTE1MDEwMTIyMjQzNVowDjEMMAoGA1UE
-AxMDSVNJMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAzASsGuW0bqY2
-f1EiKGymfseXWU75ivGujV+SFS/b8BSOlUM4PI7mkLD239rBO2U6V34khIdM17JC
-72sxgV9BlkHzrcViS0t6NfdDayu4tGeCq71XwfKTDCQnbpoRCsfpTGxGf4pL2KBS
-q6DH3Si6+E3OlXLj9sZcbbRyHpFoplvHiR+dVlyMtazySj0e8n4OOaLRa738vo//
-skRceUi8EVoRelDJNODycdEGWEPt7N6AbznluzJFPN2fM0g9VqGIjbM2s82X607w
-5+aGUbQ7rXAztiEquUHljJdnQG9XU/oOcO2Yk00my/kffIc6QT7CUk3lZGfOnFaa
-UyvstJmGtwIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQEAwIB
-BjAdBgNVHQ4EFgQUZJ6N4MblIU3XVwc5i8KERpbe2/YwHwYDVR0jBBgwFoAUZJ6N
-4MblIU3XVwc5i8KERpbe2/YwDQYJKoZIhvcNAQEFBQADggEBALjKnsiw1Zz787Jq
-TB/DKXjQYXbL8lLSHYTCD3Mc0/CnccHdDjmy8IEzneUnsPejriWSP8cGJ+H2k/Sc
-RBOLc5rSy5mdH8BJXg+H3v4FO52rOi8mQ4wIaT9qwQsnYgZnmbghLKa8cbfuGTL2
-HpocmfJ+IJWDvm+amyGrCqYBVJT7w5RWx19mHodQ5FaPZufbVWkOYpU74cam1mSM
-JWlt4Zwy9mF01ayRhK7nMmVONMfm3+vQud5vEwyivPE02CXZGAAnt9GqmWN1IJhr
-PcCC1fZub/CyRU5nebqDT+4jvm5vRZpPPdFfzSUcpt0iuGwi/Dxo99PD4naWSAnv
-xcS6lb4=
+MIIDAjCCAeqgAwIBAgIJAKtRueauTXErMA0GCSqGSIb3DQEBBQUAMA4xDDAKBgNV
+BAMTA0lTSTAeFw0xMjAyMDkxOTA5NTFaFw0xNTAxMjQxOTA5NTFaMA4xDDAKBgNV
+BAMTA0lTSTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAL+jnXyYfZFm
+AB8xTTnLuKbYIij/TPai+IcIiYxORu0dSECLL6fTlXWjysaEk8qmTXapO9O8kCKy
+/AeMlgGCDIxDKOSACzC3bKZL+XRKFreCmG3zUi+vlPz2sF3mQWDHjrnX/LdD8y6e
+lRzkJRZTfgt/hoepDQdix2XMPv67j3uk11AM+JSkVcyd0EmCCm5sPCQ0YH/iK2AP
+4vU5RRCvty1/9ojRZeaTF/vOJjRKiidyoMxwOnaqeuGb5jEtch8XaHw8+cWYT8Ke
+oOJaK46FH7sJOVUATLMx1p1Cyw3q52xwgE46AbRtllzMkkId/zZDlUT+fg1Sah82
+8b7zQEo4xfUCAwEAAaNjMGEwDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8BAf8EBAMC
+AQYwHQYDVR0OBBYEFFqLxclY3lz+O/Cle3xD9UmWq+1cMB8GA1UdIwQYMBaAFFqL
+xclY3lz+O/Cle3xD9UmWq+1cMA0GCSqGSIb3DQEBBQUAA4IBAQAslk9BIfH5ow2R
+6h1JA1cFedDOgYnkpR5ZMcht2XTjOV4cksx8jllWPA6Rn0E/WZLfrjgfdDrHtAf0
+uKTkMmB983xrorB1L+OzvOOI+cg9Fe04V4mEus00f4j4qgUDipR2i6y3+a1hoYW9
+ykSvi2Ly2R4IYtCYNI3qGDSIvLk24S2O+u3BQFT5cieIb7l9VJuf6JRuNdxhmSzz
+Ie5+YCmzowxeg1Tr0jMfIDWK6hYbNzXr+nlgmubtgzcheRuiRLKB9MTpUZJ22ftK
+11ZEUxgQev5xRIiSkPQjmeU36fXibMwpYitiY0V+cfjywiVluCM6aMli4xlcr9as
+WEnidwoT
 -----END CERTIFICATE-----
Index: examples/evaluator_rt1_typed/ISI_private.pem
===================================================================
--- examples/evaluator_rt1_typed/ISI_private.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/ISI_private.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,27 +1,27 @@
 -----BEGIN RSA PRIVATE KEY-----
-MIIEowIBAAKCAQEAzASsGuW0bqY2f1EiKGymfseXWU75ivGujV+SFS/b8BSOlUM4
-PI7mkLD239rBO2U6V34khIdM17JC72sxgV9BlkHzrcViS0t6NfdDayu4tGeCq71X
-wfKTDCQnbpoRCsfpTGxGf4pL2KBSq6DH3Si6+E3OlXLj9sZcbbRyHpFoplvHiR+d
-VlyMtazySj0e8n4OOaLRa738vo//skRceUi8EVoRelDJNODycdEGWEPt7N6Abznl
-uzJFPN2fM0g9VqGIjbM2s82X607w5+aGUbQ7rXAztiEquUHljJdnQG9XU/oOcO2Y
-k00my/kffIc6QT7CUk3lZGfOnFaaUyvstJmGtwIDAQABAoIBAFB1j0JUUOJKXre7
-UZNLtiXNpRytjrCDO+m5RS1h4IVANjMbfXQ0jy2E/PevmAFKnMWgk9pIWb+/J7Kw
-Pafd30nY3LctXuR+8cWSrF35sjBDmj8Mvy1X8zIYmAyAajQsPw/Kq8rkyaC3KaNS
-F0BbLdF7Lfu2gbzy4cTKIy92/SSN3EAyWxa4nY4k/sMJ9f4nDU7Fp5XEpk60Fljd
-6NlF2CFfY0oiSGaQhK08lv7uVY7cQ8k4ECG7llBUz+w3/LfSTgDfaZ75Ion4GuRq
-q2lCiU7mTeT7HrLfxdMVokU1LAjDfpB7WEG27af4C78MIVUhddWZFT6hWOXBNbrK
-LcKz+DECgYEA/uB82isg5MnedxOQxDQEuYWRmyW3W8x/NGu2AzyVQkaFxkXwFNds
-SpznsxzbtYRerHVFufrKJ/qbpk9OZ6GPSmqTfOVKFyMxWPJFtkbyudu5IY6EnIND
-FGOp11YV4eNOigeWWqaItFK+wZS+t3+8vIS4UlR7TVdR4xCuDbzzdTsCgYEAzOrQ
-VOXSrpHTYpcAGXNJN/YaYV1/fI/JOzDNcfKlUVlJAXAv8p5NqG2rvBHGHPrVvG2G
-VTcWy5WgFdeOYMXcFbvSiuTFsSBILQCHHwsnEMVqy8Ii8oHXgf33WsIAswJVv4YQ
-z7GLa+NKsVpDrvBPa1Y422PZ98KNEhtUNLHcrLUCgYB6Ma4p+ptelNmvRRYWusm5
-GCxisYZi4Hvr6eftTVJR3/WqxUUA+PbWHruGx8MeF0Q8ckzniTD6Uc/lwAfa7z3/
-c3EaY+NNjHXQKvb5GLKuIIV1bRpu3w996vo2XvNGxO+WhWS0OTs5GKKTtHhrCTa3
-OvoTnqUuwzpjHlAUDg66mQKBgQCISqFX5ifzjfAfgblCNCh9vQUcvzgc2/GGmdX7
-NNz5tz3UZA6v+tRB8venNdcjzT29fsc7BFH4BEOeY2lCOjdAiVTmpnRKc+Mtc01r
-u1o3UGbQsQXXb76rqgQL7D7U0PfBU+T4jujhUCKMxTGBODpKdOWKHeaKYG69nUmr
-ZqUUhQKBgELe3SA14ogS2tPqziTcCx1baaHsa0AmQu5NrTGKw1eGLpbllmQAUmwJ
-NI+vIbvpxp0QK8Ck7mZlvYHtLkM0f9H7rih9LLMNAWKYVVmNrh5Ja0T7UUp5f5jQ
-4ulqlfv9XkhII9erF29P7AQhD04d8ptOycIxhgFeEQmSGk3PICnz
+MIIEpQIBAAKCAQEAv6OdfJh9kWYAHzFNOcu4ptgiKP9M9qL4hwiJjE5G7R1IQIsv
+p9OVdaPKxoSTyqZNdqk707yQIrL8B4yWAYIMjEMo5IALMLdspkv5dEoWt4KYbfNS
+L6+U/PawXeZBYMeOudf8t0PzLp6VHOQlFlN+C3+Gh6kNB2LHZcw+/ruPe6TXUAz4
+lKRVzJ3QSYIKbmw8JDRgf+IrYA/i9TlFEK+3LX/2iNFl5pMX+84mNEqKJ3KgzHA6
+dqp64ZvmMS1yHxdofDz5xZhPwp6g4lorjoUfuwk5VQBMszHWnULLDernbHCATjoB
+tG2WXMySQh3/NkOVRP5+DVJqHzbxvvNASjjF9QIDAQABAoIBAFlqy0nekQBtunLT
+ezgTcUYQJOhCLzQJWLMQ7bUUtQ1gE11iVEsXc25fjXbRV3A/5ncOgcbK/eni36va
+EggEGTy8/XCYuh/yBfUWEAANrcnUWrE6zkdHwtnBdQtrK2gv1M2sFNOiFe7Tubmw
+Tgm7zV0qFKhp3ZVrpqQ+B8qt00YaFiypDsfS7E7rXnO/j/8hsj60cGTl1Or2CP+F
+r6ajTp2OBJ5hxalnJz54rfPkHaeitlgJ+/QT+cq3mxHdVpvE1WCKe1AyqVCho+oS
+57YvNte9kw8Qp3pDXT9B2N/EGfwUdoj67JaSHtqOfTf2NK5zBYPmlVFu1IBU5yKX
+yr/WXOECgYEA5nQCe55QxmK5OduITj82V9qcI3ZK5kb7e4vudfubwfTCZqU9x2KZ
+jr6clLmK96wXG6n9aLzyw0Je5PGg6ZVskjhzp13pHzoQEozlzeyP+sBgpLfH22al
+vOABE7gg+yYDomsH3qAhS7X4m++aVeYxtR4Zdg1ajOhgP4xGKoczJJkCgYEA1OIb
+yfMsOF+wwURTbqf3ot4A5JhraWy9ND0KsCvMnJUmqOAVFGe4u7cruKNGgxJQYJ55
+Lo0ODmokKus973FI+m+fQ249WJtI7GsDanDQ5P6Bi3EUHxBdMHahuxJ4vn0J8wOb
+gfGkMQdGsM7OZihMT445+CKgRV2r/wehD2+Uab0CgYEA4tacPwwlnDE++4lxEPw9
+xJpliK5+qU6Daifh8HZa6b6/wAO03NbcKdrMC8Ta2lGlaVCZJIigOLzS5W5GIsY3
+WXKBvOO+fUNM4MWZymmpi3vjZR+VdQwD5fdkeAGNTUks2Kmb1HIwc/LJpMxjUVxF
+326iR0Z7tClj3Al6Y5AzMjkCgYEAoCxYOETM+sWU2nWsSM/8lQBwr463EqWMXmen
+SRJLa20Vn26qraW06xhQvyWqgigfbfMOvqXG87WM7PX+rdAQ1s1xiWzCn46G+csy
+0L19jy6nDeHQ/+ZyF2rLGVQ2oSy3da87LDRCE9mjqJiR129uq1UZ7Mcwy8BFDygQ
+WOrdQgkCgYEAkvfz31WG5N0WW7zfYTGbEW0quv3QOTcva6rFxxMVEvK3ok9sZ5sp
+CHhMsxu7Wy8JhZt9B+oTa+Um2Q7fC9G+py7sWhbTyVVNox9KR+LKEPQ7YqNUMCiH
+PnQGyjnXFkKmovDi2QhRVJqBZE2G6n4oxTE1D5ge754f1grkP+OEArc=
 -----END RSA PRIVATE KEY-----
Index: examples/evaluator_rt1_typed/John_ID.pem
===================================================================
--- examples/evaluator_rt1_typed/John_ID.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/John_ID.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,19 +1,19 @@
 -----BEGIN CERTIFICATE-----
-MIIDAzCCAeugAwIBAgIIL1XKhWx8ILQwDQYJKoZIhvcNAQEFBQAwDzENMAsGA1UE
-AxMESm9objAeFw0xMjAxMTcyMjI0MzlaFw0xNTAxMDEyMjI0MzlaMA8xDTALBgNV
-BAMTBEpvaG4wggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCztyKS8eeZ
-p0qrrTv3101EaJRVY/SokeWrdrDAUER2nL9ZhIVrR3IO1Me/6DwwqPo5+i/FYM6f
-NBlwpIHMUsA66o1LMYOw0vdG0dKA7Gn4T5Xk99noyzszProFazQ+zaQ/M39rPiPJ
-HPuTIlYvuiO9w1dx1TKirGPqHk6OsqBauI+vUwMIfN6RDxjhGldpWz+djDWlGe34
-JvnpEC0hDQOYyMQNKHWEdBHMMtWAL1Ml4PZgByexr0e2/yEV5OoR5AugXjJSow3W
-uzXYHZOQIfMtdyfWjNRaq+C4BnRR9YMf65zky+nnEf9HkG3GTA9R1pt2cUnYNaZW
-1vKoDilJdaeFAgMBAAGjYzBhMA8GA1UdEwEB/wQFMAMBAf8wDgYDVR0PAQH/BAQD
-AgEGMB0GA1UdDgQWBBTCMcXRcbNvVxooMjHraj48xNyBHTAfBgNVHSMEGDAWgBTC
-McXRcbNvVxooMjHraj48xNyBHTANBgkqhkiG9w0BAQUFAAOCAQEAP+DKV5LIGD9c
-d8Fwg2DApaz05AA1SeWvRmk4xPv3z1Sc4Ropij7n+5v1Sg9UR+1m7N+rpqz/MrF4
-LT3EHQl0EALh0pQ1tYwMJv5/mX6pLDyXzOwRneV2h3ic+hlb7pjtxPkB485adoXO
-X1Hu/Yc4eArok0zv8BcQKOCAzlFFerYDp7xbKUIhEkXzt4+SNNZIvVm9/V104dx1
-3Ez84TLsr2BQNzwElYpVMnVejmCROlRx/Q+UJGQXynU7qMEMBJzqEAdj16L5Xys/
-eNMGVM9Ak5Cgr2hr/6DuQBYyp0v7s4DcWwKiQw2KP5wNgnQ/hddNvzmLgDwrdbfK
-SqLRBGfr+g==
+MIIDAzCCAeugAwIBAgIIamMBgrQIV1QwDQYJKoZIhvcNAQEFBQAwDzENMAsGA1UE
+AxMESm9objAeFw0xMjAyMDkxOTA5NTVaFw0xNTAxMjQxOTA5NTVaMA8xDTALBgNV
+BAMTBEpvaG4wggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDKPdH4NGO1
+XpUf//jbHoJA5kPESkuCH5fmn6btstqsnMJ7wTOg+GFxxK6WLMLckGfANzNsdNz6
+Q80Zn/NasdbMq6p6pT921a7WqslhOH3npje2o/309/0tQeK7XOopDRmzP9R/60UC
+a/CkOsMUvxoVHLyr3PIoOZrOjtZKYBncSWgrD4UDLIoWJOQUWlp5hjC2kim7s7hV
+2SF1OSgqpYgKxf6JkQg3Wuf8U64w+5mUZOU9ACykPZxpwBWnavnRNAN39i8pyZga
+k/xwuuppcVUvLlzfFg/Jg3r0RXs9U9cF7q8gdpM2nJN49dQyuw/MSPghUUCuHxPR
+0Rdo7tMHNXk1AgMBAAGjYzBhMA8GA1UdEwEB/wQFMAMBAf8wDgYDVR0PAQH/BAQD
+AgEGMB0GA1UdDgQWBBTptjaILzZ3X0NCu/UspuEQC/bHCzAfBgNVHSMEGDAWgBTp
+tjaILzZ3X0NCu/UspuEQC/bHCzANBgkqhkiG9w0BAQUFAAOCAQEAUHwlyzhgUlp7
+rlHrHsS/GHIQHihjgITyaR4cvza+Ul54x1U9OSNVu6XTX7P/NzIkCtCpvsRNUYmZ
+g5T+WADUUPpnkixmBkszuhrgHPhs1rAWDmFv9tjEnWaXqHJzNVZ3vuJQAOiHlfC9
+7CnatWVvJ9XvE/V9DW1eCXA8Iwa9cX9wytNK5qNDmP2hCLio07bD7dvND3vm6TGe
+B5j+eEoJnr1wLQ/G91ejKXwXl93ajQczvcOPV3itoKydID3ezy7ebVG4yE3ypwR2
+aKeJJMvy1+heJ0V7go4inOCQFv4xRoETPqONSxPu6tHylimSDzFBdFzN2rFe0Wln
+atusJaGITw==
 -----END CERTIFICATE-----
Index: examples/evaluator_rt1_typed/John_private.pem
===================================================================
--- examples/evaluator_rt1_typed/John_private.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/John_private.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,27 +1,27 @@
 -----BEGIN RSA PRIVATE KEY-----
-MIIEowIBAAKCAQEAs7cikvHnmadKq60799dNRGiUVWP0qJHlq3awwFBEdpy/WYSF
-a0dyDtTHv+g8MKj6OfovxWDOnzQZcKSBzFLAOuqNSzGDsNL3RtHSgOxp+E+V5PfZ
-6Ms7Mz66BWs0Ps2kPzN/az4jyRz7kyJWL7ojvcNXcdUyoqxj6h5OjrKgWriPr1MD
-CHzekQ8Y4RpXaVs/nYw1pRnt+Cb56RAtIQ0DmMjEDSh1hHQRzDLVgC9TJeD2YAcn
-sa9Htv8hFeTqEeQLoF4yUqMN1rs12B2TkCHzLXcn1ozUWqvguAZ0UfWDH+uc5Mvp
-5xH/R5BtxkwPUdabdnFJ2DWmVtbyqA4pSXWnhQIDAQABAoIBAQCl0hauq1HdLsTx
-PviUKC59LlmfqIj4eRYHbY6NBAMHxn2wZVyNrfCJyr88TVYsN94aXMRzRG2h6/qF
-OuUg2EHSmtUgSmGOaDoNOFEY8AqfOR+/kwmXiN3o3Lnbgh1EzY39WtD47O8sA/gE
-vKv1gbS0xWcL+4GrI5FVVf16IUtgKFkQdFhZWNUE4Q4chkAUUykzw3Z8CSK5yGdC
-tyw4rdqCWBfmEmvY22e7yEh750A4mlcrs3mV/vPoEIlKWKis9CAUVIDaaPXGomN9
-orrL5c1AVFDX4nkRySTaRBcTryLeA3iQCF5ilPgAGK/bVbqQuiQ1aLktkGQ4W6PA
-NwoSxxDBAoGBAO8j+dbVmojdzwjU5dP80/bNGSa5UtsG0FdPQBZnApnKqjeppRhc
-AEahAEA7VCFjUkO7XEFV++t0vkrYFAt8zGnI8AjK9+nlzWrBE7l3sK2VBMMh2hFr
-Cq+snQqq8k41gjxqM+3Qa0u5vj/y1Y4tZQQIbCZubJcfJtQ1uIeRDa4ZAoGBAMBi
-pmFBHLaW4q0E8ocFHZnqcuV3+djwmNWTcZ5PPvixjJFTBJ8gph54edTy1DePfZHt
-MXgRtrA2niM4QwJFwMgecvmV/K1JQ7UgYGzeUF08Ha85IAyw6eL5CMxncPqoZJcv
-svV2l/U2DJFUiSY0awAO+VU03CUeVp0dGizXr9pNAoGAae6u0qrmfLB88LWWZXR+
-1Ln/5TZ87Ic1LSfvBL122nd7NZMRjhvbB250dP+TAgNEQrqxYEPdh2y8itzy7C/J
-QScApXR7o4Hnn92Nhj/t5Ma5SFMrjUG0hyNYoYweL+TmHysQe80yamYKT7ubPBMB
-x2qPtep+cecbxS9S4cKwo6kCgYAzpoia1btavhmvcAOZAmOXHh2ow9Q9TSMLPCGl
-6gqzBCAEKDC2dDKFPb0f0e3t2MVSt0avwLm2h4NfW0yKQKXoVFxz67PB5kiaSU36
-DJmw3mHt2D1lit3QRSH6ls77TNhsyq6WPje/6rnnDrYfnrUXd+2y1ZVBFesVFWog
-neulhQKBgFYaNvcRSRbbl49YyYfcNDqAxFV7PvE/600QXVxqP667f0GFqbZcZjDt
-2GEruwzSYuCYsProXw/4l7JY6wPHGH+U/uFEJIhtWdzjCyIicbz5m8SbZZ/p8mbG
-hcC0/p1e47okr0C4P3QP1cEQBoMXZa8mcScSExjxUTvNqY8FCA8D
+MIIEowIBAAKCAQEAyj3R+DRjtV6VH//42x6CQOZDxEpLgh+X5p+m7bLarJzCe8Ez
+oPhhccSulizC3JBnwDczbHTc+kPNGZ/zWrHWzKuqeqU/dtWu1qrJYTh956Y3tqP9
+9Pf9LUHiu1zqKQ0Zsz/Uf+tFAmvwpDrDFL8aFRy8q9zyKDmazo7WSmAZ3EloKw+F
+AyyKFiTkFFpaeYYwtpIpu7O4VdkhdTkoKqWICsX+iZEIN1rn/FOuMPuZlGTlPQAs
+pD2cacAVp2r50TQDd/YvKcmYGpP8cLrqaXFVLy5c3xYPyYN69EV7PVPXBe6vIHaT
+NpyTePXUMrsPzEj4IVFArh8T0dEXaO7TBzV5NQIDAQABAoIBAAVdzJOEeFzYrKZT
+uXu+/H/SXFv6CLTkN7ij5d8KzuijpDl6b+9Gh/dn26Yae/U0U7xy+odXNoHhiLC0
+YNW4QFXf/D8S4XM6yk/h6kQNJrId4/6RrWxxpCMuS2DjX0dFlLf/6piWWpds287P
+zFthksSapZr92uMcXDI88gy5LhZ9RAD6reRuF5i5M9kv74CbQ2UU5HjRE/Jdpanm
+jKMvfeEsfvzbCZHf6cMJzA52fTm1jGxKFDUp2+XXwdBcCfjee7GBuPw8XLK4JM5F
+7o38rxM0uFV9l1Q+9n+zvBZx0dadj9IU6KIklcoLsgBbDUfLVEVa2ZbIvrqD+Ofe
+Jqmq3KUCgYEA/643GW/T59BgaT+Qlm70dnduWFAFoA0/P7wypLbLhN3Ry9HiNdu4
+YNJt0G/K0Gx5fSXaesFlzpz8nsC8Bbntfe5TSf/nnQaT9/mB7BlhYWdnX+IGXOGn
+HwaaIOKJlz/bV4cW2JN7ou6zp8LHtMVGFyh2xTUGgRrL0IILou1Xcb8CgYEAyn6C
+6NYI/SD+i0LvDk2Vs7f1N8Ztprfz0sYYio7FsAz0LKFNmYwkt08PXaSNIgrOF5b/
+74gmszLU4solaNfCr1jZJMPQeO58Cf+UJHPMqu1Ypc7+y87watiVcw9IzxfdsXNJ
+P2n6hwtKjsRLcPwHI2koXX7vbP2UKCiJBEJF6gsCgYBeeGmFbYtXkOe+m6z52H9d
+Ml3EJbUeYSaojwoLUDs8mZVGAQPbMJcct0O6C0Rd5GazNgRW7RSH1fuFUONoHj3B
+FQkTQ4m5vE96BWfa67nOep14kRQWx42vagoS8oEyMHcEDTcEyOGa3yXka5TMl0OB
+lQLldOU1WMhL/3D7P0TbEwKBgDnM4Os7ZTdz+pSf14L6rHevU+TG1DfZnFSWzRyH
+4m/9UpmGtZLVyQk2HQm61bpY4Tkklgu2jm1qXhAaaZFCvUS2FM2Ew3YxhOCJvqyl
+DU/hDgPOUTa17DRjfE1qmHrcsiBb6xWZ17RCida0u2AV4Ke/9ZCykf9HZsoLwAii
+Lji/AoGBAK6A92zgtw2fwV3DQp2f3I79BewkPcMDoDPXr5QusikTZpBy2YDcQAdQ
+awPT46lWZ6uH3m/RZ1mFtdvY5w6+mdS7AB7fiFq7IZgjNn6ULv1cmvZVGMCmgnX+
+1IxhAR5Dps61cMBjDWFphT9eNjd1h8dB1dEo5f43eBZhsE5pIe+3
 -----END RSA PRIVATE KEY-----
Index: examples/evaluator_rt1_typed/Maryann_ID.pem
===================================================================
--- examples/evaluator_rt1_typed/Maryann_ID.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/Maryann_ID.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,19 +1,19 @@
 -----BEGIN CERTIFICATE-----
-MIIDCjCCAfKgAwIBAgIJALbP2vCmtPtUMA0GCSqGSIb3DQEBBQUAMBIxEDAOBgNV
-BAMTB01hcnlhbm4wHhcNMTIwMTE3MjIyNDM4WhcNMTUwMTAxMjIyNDM4WjASMRAw
-DgYDVQQDEwdNYXJ5YW5uMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA
-wiQhSwuKZ6H4f1uOg5zxi2FnF6b2IhiWNrbjorG7nJMt16hSLWE2IYgY5WN+2cE2
-gFlnFwrbGFxV79Tb3TaD5vEgm7t8N8px8XLhmVp//j7DWVRLezcDiuVODx8lpQ/t
-b6lHGOnfs2DWBB7f9SpOJReaR2laEWvii6O6+2ntgoOMDU6r5CjUJYYnJ+80lC8D
-EMF2ttAvE1IvVe4fKqJaWRcYqaHeZkKDm9POkNxzHY4j63UNo9M1B1HaT16pIcyt
-KUjetHMrFRv508ArZR48uozsEWTJO6R5QBJEKlQRVcxUVAw3rdgkxgWys+EMF9bu
-szJykOnzUGyicR8thiLUwwIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1Ud
-DwEB/wQEAwIBBjAdBgNVHQ4EFgQUcebf8sMmL3sO0y6Di8KUpkpgGFswHwYDVR0j
-BBgwFoAUcebf8sMmL3sO0y6Di8KUpkpgGFswDQYJKoZIhvcNAQEFBQADggEBABHj
-LcLkliYszcnZCneHKvfeMSt/W3gWM2fGZxrGBg/q+7twrfl9ohWE30dZWE9Rmo9+
-Qwyj7QVmC9LiHJEjtBlqvh1PFiHvAtsy9Ar8YFuESMJ7wrbrDgOaD1mXuAH/xW2f
-4iM9nbAamEZlL4NJH2k2mihLvZMWIb027EC9fSVDXAQwB9ZZ90OVAmBZWlGqcPLy
-IiG9AZBWMj67CZmhv8ZOjfPtEWfLtYEtM3ExrfrL9ZhSfBcUa6pf3/Qijz/32QlT
-tm+aeEPKqI/R57PVhYfLqlbres+fDmyngYmF6kUQIcFNFr6mDUSylV8l925rD+sN
-mSv4+SBdXr0Ly6bVLaI=
+MIIDCTCCAfGgAwIBAgIIEoyrasP1PW4wDQYJKoZIhvcNAQEFBQAwEjEQMA4GA1UE
+AxMHTWFyeWFubjAeFw0xMjAyMDkxOTA5NTRaFw0xNTAxMjQxOTA5NTRaMBIxEDAO
+BgNVBAMTB01hcnlhbm4wggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDg
+FVN2N3UhQGippRrGArKJfme4uXNR5tnkBDEYZBGSCGbnls3712qGxOZKPFetyrZF
+ytfcn8guTtrsXHFu4avSvchjHs+Jb6jhWQsspGvtYXFhwl6XT473MQu/mjI3L0n7
+UNEa6EKsAr2JDjkukFRqjpeLDT9CsfdxPC99RSE8CyyL7JHIIGnJb67O2P99FXvT
+WCGupe5Ll7UO4/9pWXQTu2bFeV0CzZVIKFwbn3jMfep530JqPcCohkHPgXTSzZal
+LmkNs1P4FQoSxU8ntp/g8MonTWaFN1p9DXhKQFHoFcO48++PiuRcrl07TnWvxA5B
+2KFACvZ7QmoGSCKz6DRnAgMBAAGjYzBhMA8GA1UdEwEB/wQFMAMBAf8wDgYDVR0P
+AQH/BAQDAgEGMB0GA1UdDgQWBBRJNgG6YnJuM5ng8lcjhVOxNp1RozAfBgNVHSME
+GDAWgBRJNgG6YnJuM5ng8lcjhVOxNp1RozANBgkqhkiG9w0BAQUFAAOCAQEAU5Cg
+VkasB/GmbmAzG3DPgez8QUcfqB5iZyf2/JJGe3S9q3eGrZZ5Z7ExndoxUmMf18XR
+bmPEFqpU4SeXQSrvIHaswuxwlEJIuOZcuPUPrTojjlalNrcbXKqXdegXXxIh0F/x
+jEWaFtj9ova48K5zzD8liy2dJqLtWWO3XHmfUuf7P7xX+yzw/qONc3z/n2Zd9PeY
+6XfWLeJ/VgbA61LI9CY2cdsefw84QOt3RyXaAM9eIazFlWdxcz3Y34f020KByVc9
+SNjH4ynC/1UB+ljdA2PzpWHnCG37ZMfMDWC7u0p6Qd+EE7URJ3qJbirBucga/vt5
+SAsUI2mDXo2YY1lTWA==
 -----END CERTIFICATE-----
Index: examples/evaluator_rt1_typed/Maryann_private.pem
===================================================================
--- examples/evaluator_rt1_typed/Maryann_private.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/Maryann_private.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,27 +1,27 @@
 -----BEGIN RSA PRIVATE KEY-----
-MIIEpAIBAAKCAQEAwiQhSwuKZ6H4f1uOg5zxi2FnF6b2IhiWNrbjorG7nJMt16hS
-LWE2IYgY5WN+2cE2gFlnFwrbGFxV79Tb3TaD5vEgm7t8N8px8XLhmVp//j7DWVRL
-ezcDiuVODx8lpQ/tb6lHGOnfs2DWBB7f9SpOJReaR2laEWvii6O6+2ntgoOMDU6r
-5CjUJYYnJ+80lC8DEMF2ttAvE1IvVe4fKqJaWRcYqaHeZkKDm9POkNxzHY4j63UN
-o9M1B1HaT16pIcytKUjetHMrFRv508ArZR48uozsEWTJO6R5QBJEKlQRVcxUVAw3
-rdgkxgWys+EMF9buszJykOnzUGyicR8thiLUwwIDAQABAoIBAQCI5z+PEyFTuTVq
-Yh8akqcGufYgCL4TBzGOfeQCi8EYRfWS2YCxvZaViMq9oC8I0aZkVidLaX1dLWfw
-izNMSLA1QB7Vkx2iniFBudh68wXFPW82ZCoiRoY6AT/NjBJY1uWB02ZunCYC8aua
-FkeqNF4M7BsAdrtsA58rB5fIyUcSvAIvUZxZQoP06bWL47vjYI/T3UAKQdfzOb0X
-JEqAVOHjTu3O9r9RW6zZZbkaqxEyYqV1Nxku5s7LxFmyUuG+YBaxupM2CtW70IFL
-2WYbmgO/AmXavtlsdzcfqrYJxfwaqDe1W7DEAJgnOHPwmJbKJoaIUTV5z8ij1ONa
-iTNMx8ExAoGBAPznNiSRq3FQs41zhJfi/OxnBLq6MWwm6IUV8uaI9czFsLkxk2Iz
-gNYdTfx/pnOukSduH4Dg/wrf3hLfxpb6G6EqTG1uSvkRhskJVVsUGNvANybew748
-sNdiSoRq0OI5nRO8rwq8T78BBohLi/lN+CQF0joJe89S70CBS0SiN+hrAoGBAMSE
-ttVVUjYavIHMmuqO0OwL8CD0cHC/R7DK45CSCM3DssPgGq5iTPaDY32XH4rHQh4y
-eP5pUwoBlxQfySYjtxyudwcys+BT1dE61BgsMeQTtbv/A+htwyvGKVevAU9Ek1iO
-hsq19JGTVr8/viQmdsPQnOqXMCzYG4NA52GhkTsJAoGBAMk4bavK+029mB8Duove
-3r55eRnY61nR20+Ilys17dxvrpyrBUktEWVLC7HLHvUMABIPXKF+Y26TkG4T/j5B
-4ZnpvcWT67Mgbs2lz3QYGW8/EKKsu7GxOEMmwYN6OZjFnmUFy4APNKQUfM4Uzdoe
-X0DKIOpsgUYEBricJvcE2tbhAoGAYyhDyKjgboRXEXdXw3qEWFY9t6MfCQS6+62j
-3VKSNqDEFqmBTPQ0uT3aeYhDVhbseagl/NjQGYBr5q+TIzdqMYKmdG9U65/hh00T
-r469LcP0MwOdyS15CSFXwvJ+yqxjXI+t26Kr4LhjUOSs4Di4PF2Kj6Pxnu78EuIw
-3cZULWECgYAHaRV5YfcP6AwuX5FKTfwPnepLlKhT8j+j/IBcE/dLT4KIICliAWeN
-c2veprOUriwdkunD7XI47bgfoDU4LmCJQDMMc+JwBzokT+v8a2nAX38PH+rdN2rC
-+5nFqL9wj4+417Rj/o829abC1Qs1TEySom2bRoBmDt9NPKP3/eJm9Q==
+MIIEpQIBAAKCAQEA4BVTdjd1IUBoqaUaxgKyiX5nuLlzUebZ5AQxGGQRkghm55bN
++9dqhsTmSjxXrcq2RcrX3J/ILk7a7FxxbuGr0r3IYx7PiW+o4VkLLKRr7WFxYcJe
+l0+O9zELv5oyNy9J+1DRGuhCrAK9iQ45LpBUao6Xiw0/QrH3cTwvfUUhPAssi+yR
+yCBpyW+uztj/fRV701ghrqXuS5e1DuP/aVl0E7tmxXldAs2VSChcG594zH3qed9C
+aj3AqIZBz4F00s2WpS5pDbNT+BUKEsVPJ7af4PDKJ01mhTdafQ14SkBR6BXDuPPv
+j4rkXK5dO051r8QOQdihQAr2e0JqBkgis+g0ZwIDAQABAoIBAHNuiO/84XmflErP
+olseSJpLY2LlJWKraNLs1d2arvJrIZdrN/DjpxyFkZvsOb5tDjglpc0hAh3YwS3A
+8S4NUlXdLbzhwkcqHfT3yanViUNfTujtF40ajqsHuOWaqQOEeLfdidoyiyXQw5I2
+oX47G0FI8wfOaygQRUcvmccONXCX2idg1tOR8JCjXEqQTtB8XM9T56wejycA2zG4
+Rk1tkG76iyNwLBK42MZboznh0NdGuhbyXclvEykT4Q96B85H6v2AX1B/W7rcGHc/
+GT3QTmze/MDC+NsHFCNhdpb+Enb1Qr3c0S1Js0RfB+mHZoiDMYZ1qhHgGrVydtFJ
+7ZjO8gECgYEA9Qkp8gBqtOhd275ebtDKzx1cd6W9BQh444xTFsqzR1x98u5xa3jL
+w/SNORqSMZ/rOuTxP7DhU7pGEd1C5PgZ4QKWv7ROPxbHbTDfw4PEYM9yqqkA1qbP
+ykBXPrqtyinJDyeRuAR+y83p1Du9NZ3yNXfVGs6UETT1XGJ0TX7Pk28CgYEA6hwn
+0xFo/xychke1Vm4WZzkh1EGkwuFzuwuEmAPth/rbdwKAbMkPUbJUNYZ5LYFSvHXG
+iyCiVfAjeixGorfiG4I7uEQNJejjLw5dxt8U2mNodC53zYSfgGKlCskq2GM+6/2c
+VwL1CiJnv4fSpSK7U0GWcrsnc8qwsOrrYPSTkokCgYEAt3XA/fvp6MEBZQFHWtjg
+v+lPzhU9TINnX5c0rp/dUtShSD3WlYy/o1t6UQLf6l+9kz7Okc0xJ6sTw1RSPXS0
+i4+Qpr+sxfecINiy8IO7iHBJfhVDF3OVp+w8Zi8G55IZg0sxAwH6nUTyiYCgzYAQ
+VI//8i4xFiD8g8sDIPKNH+kCgYEAhKKTBYgVnoONQp6Z5G/WjYDW47SVLjwhH1W1
+N5LyHlpHwLNQI1H+NeD8yJ55RQjB4Tgw1l4U2u+EihFPq5zWo5MzVoBnmpTJMb3H
+74YwAFLVuQ0invOGkmxQ6T1z4sjHu1giHUH1plo7wU2oUBrPWqoMHNBf18B8Pp+5
+32JxwVECgYEA9CM6L7TqSG2Qm/EQGHe2J8w6rlfWvmcCpgv0VSpNnV6QSC7pUzyb
+nDoISJbpuQyjblN23xATu++6pDZclLwT6pL8ILZtsIzLwPHe400heKqxeI09qkTu
+/+4S8DAN/UZsZnCVzJwcSut9eFNfjoiNeLubYLJqqfQU2016aCrxexk=
 -----END RSA PRIVATE KEY-----
Index: examples/evaluator_rt1_typed/README
===================================================================
--- examples/evaluator_rt1_typed/README	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/README	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -18,26 +18,26 @@
 managerof_maryann="managerOf([keyid:$maryann_keyid])"
 
-#[keyid:USC].role.evaluatorOf([principal:?this)<-[keyid:USC].role:managerOf([principal:?this])
+#[keyid:USC].role:evaluatorOf([principal:?K])<-[keyid:USC].role:managerOf([principal:?K])
 creddy --attribute \
-       --issuer USC_ID.pem --key USC_private.pem --role 'evaluatorOf([principal?this])' \
-       --subject-cert USC_ID.pem --subject-role 'managerOf([principal:?this])' \
-       --out USC_evaluatorof_this__USC_managerof_attr.der
+       --issuer USC_ID.pem --key USC_private.pem --role 'evaluatorOf([principal:?K])' \
+       --subject-cert USC_ID.pem --subject-role 'managerOf([principal:?K])' \
+       --out USC_evaluatorof_qK__USC_managerof_qK_attr.der
 
-#[keyid:USC].role:managerOf([principal:?this])<-[keyid:USC].role:employee
+#[keyid:USC].role:managerOf([principal:?K])<-[keyid:ISI].role:managerOf([principal:?K])
 creddy --attribute \
-       --issuer USC_ID.pem --key USC_private.pem --role 'managerOf([principal:?this])' \
-       --subject-cert USC_ID.pem --subject-role 'employee' \
-       --out USC_managerof_this__USC_employee_attr.der
+       --issuer USC_ID.pem --key USC_private.pem --role 'managerOf([principal:?K])' \
+       --subject-cert ISI_ID.pem --subject-role 'managerOf([principal:?K])' \
+       --out USC_managerof_qK__USC_employee_attr.der
 
 #[keyid:ISI].role:managerOf([keyid:Maryann]) <- [keyid:John]
 creddy --attribute \
-       --issuer ISI_ID.pem --key ISI_private.pem --role $managerof_maryann \
+       --issuer ISI_ID.pem --key ISI_private.pem --role "$managerof_maryann" \
        --subject-cert John_ID.pem \
-       --out ISI_preferred_customer__John_attr.der
+       --out ISI_manageof_Maryann__John_attr.der
 
 #[keyid:USC].role:employee <- [keyid:ISI].role:employee
 creddy --attribute \
        --issuer USC_ID.pem --key USC_private.pem --role employee \
-       --subject-cert ISI_ID.pem --subject-role  employee \
+       --subject-cert ISI_ID.pem --subject-role employee \
        --out USC_employee__ISI_employee_attr.der
 
@@ -53,2 +53,3 @@
        --subject-cert John_ID.pem \
        --out ISI_employee__John_attr.der
+
Index: examples/evaluator_rt1_typed/USC_ID.pem
===================================================================
--- examples/evaluator_rt1_typed/USC_ID.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/USC_ID.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,19 +1,19 @@
 -----BEGIN CERTIFICATE-----
-MIIDATCCAemgAwIBAgIIZC1dr+NobHwwDQYJKoZIhvcNAQEFBQAwDjEMMAoGA1UE
-AxMDVVNDMB4XDTEyMDExNzIyMjQzNVoXDTE1MDEwMTIyMjQzNVowDjEMMAoGA1UE
-AxMDVVNDMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAqyol+Zlbx7y1
-c/ciEjxpp3tHds3+4shCWgwKcUh0PWb7ULlOCeKFIYYnG+r+h1ZHzCqCcSSL0AYs
-zw/soUWwnB3L84/smshFo/ha8SmW9Tww1jCLR6pz4ICsw52WKVI0PhH5dJxzdOYH
-ipeaZGCOSsNAbaeQZNiMy/j6Ci9SLYRwW1h0WayPejbXxlVslhPLZgiQV7suGcPy
-dh2VpRW96zy/RomYDrLauh33j4KT5wMr146PDn/lsehc5znIp3aI4U6DANFwh4BR
-CxkxopF+EP1ThsQVuJ/0Lz6kDvk51szVp+6xCJMrZ9cCCpW9fQfnvLm5zcWuNA3J
-UQqKDGkO3QIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQEAwIB
-BjAdBgNVHQ4EFgQUj76loHGOyGwOqV+1wDlGyqLi6wswHwYDVR0jBBgwFoAUj76l
-oHGOyGwOqV+1wDlGyqLi6wswDQYJKoZIhvcNAQEFBQADggEBAFCjCniNsX4kyJSi
-xcMoe+9wB0AnoVDevkewuco6NbDlDXs+TV2Lqb0Iyp1s+aim0DLpVgvPW/+JVyLO
-B0wZx+cRi3PSFJqDoQq9r/zoflwwGtB0dbS6qfOF6WCuVAzra1iH3gHExh83TFlL
-F+nQ7er6QmTKAnAV6S6GuFZE3iWAkEgee0uEkEguWwcc5QNIR+MqPtTZ167TIWGI
-R0GaQU9tXnEOb0iBjWi3KQQ76Z0NFT8o7B7jqwohaDPQCFuxbZDZa6zoZBo5cEU/
-hirXHmgEVN5R3O7JezZ0QQrgvoIOE1ckcE+14GEMDexM6i92hYkXLlIe5wnnQqQM
-oWKFZ7U=
+MIIDATCCAemgAwIBAgIIVH/V6vHlbXAwDQYJKoZIhvcNAQEFBQAwDjEMMAoGA1UE
+AxMDVVNDMB4XDTEyMDIwOTE5MDk1M1oXDTE1MDEyNDE5MDk1M1owDjEMMAoGA1UE
+AxMDVVNDMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA2dfa810plm9c
+J2YwG0rUdTVhMNXV6qgMkVCRX/79+5u/YzarzexyiMRYFoKkC+t0JwgPZc/PaAGy
+VcItRo78i+ehVMawMcKKwTi6wWyumXC47GSl1Ek+xU08hAXdG3DASoqeMIgdHHwc
+rXkTP95oN8/8AInbl7SuA+V/13WH9pdj0I/VGTvO9QNCahPij2KG+Lar+RYZd0Ky
+7Wj2GlXoDqS6fOWplm5/3ZUTXWOyGuXzGohHLU4IekkcVlbPfrsasm1K8+HfflHv
+lKGyAlNuZa4sPysUCCw8R+YC7aVgf0x684q+8fV9fVrBlT4ZCW9vhXQh8yJgNPFh
+1gZEd7w1FwIDAQABo2MwYTAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQEAwIB
+BjAdBgNVHQ4EFgQU+TeNDXHEzMdDoKYqYn8QI59GIbgwHwYDVR0jBBgwFoAU+TeN
+DXHEzMdDoKYqYn8QI59GIbgwDQYJKoZIhvcNAQEFBQADggEBAHtMaw8ROeL9bXqI
+J7rHd48SJG7oitBAwXCBiIr5e2iTZW1HEaDDLboswdm67inWPBL9SSF+0rF6WUAw
+dU6iPto4YJihHVOEnd7E5S1eZvPkIN+OT5jA0mHy9qPtMYcuCYATUpDo6CLQmZSn
+mNoszGmbBuv1VlyDqBW3RkYfgld02TJSqAZ9L8D74o3GIDzxeeQNlKIqneH9CWZx
+fAB2yndj4XhqBPky1fV/n6S2Ah4O6gFtcKvx4TzfuwqntYh2X1EkVvbg1sTJaDpd
++tKPWk5bG+F4xqH3qI0BcABcYpngBMOWqQRutozQUPaJGlErq4ikZUhE0nLeMciI
+NU5n8KY=
 -----END CERTIFICATE-----
Index: examples/evaluator_rt1_typed/USC_private.pem
===================================================================
--- examples/evaluator_rt1_typed/USC_private.pem	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/USC_private.pem	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,27 +1,27 @@
 -----BEGIN RSA PRIVATE KEY-----
-MIIEpAIBAAKCAQEAqyol+Zlbx7y1c/ciEjxpp3tHds3+4shCWgwKcUh0PWb7ULlO
-CeKFIYYnG+r+h1ZHzCqCcSSL0AYszw/soUWwnB3L84/smshFo/ha8SmW9Tww1jCL
-R6pz4ICsw52WKVI0PhH5dJxzdOYHipeaZGCOSsNAbaeQZNiMy/j6Ci9SLYRwW1h0
-WayPejbXxlVslhPLZgiQV7suGcPydh2VpRW96zy/RomYDrLauh33j4KT5wMr146P
-Dn/lsehc5znIp3aI4U6DANFwh4BRCxkxopF+EP1ThsQVuJ/0Lz6kDvk51szVp+6x
-CJMrZ9cCCpW9fQfnvLm5zcWuNA3JUQqKDGkO3QIDAQABAoIBAHZuaWw0wp6HYf3l
-R3vatTgfQqlfizcbXV206xzLBzLdKJMIRIjuZTN3AWR9yrOV7YPE/hCPOvYq76It
-4IsOD09WBqJ2OT43yIfV9gbbwgnZJeluGVDzDc6O+fs39IiOynsQMMyQ3ApMh3dL
-wpYlgQ8V3mSBBpXgiDsyAMA/UdsPoBHJT703NzXpGsHBPWzoKxIE0pKlCV0o72T4
-jfb97uWFZoKOzoQt32QQZMOlHLo2/6BrX8dVveTd1bcKfwqIxDMX474Uk+Sae5sU
-uuZHJ6rgO1AHmolwDN2jsCn6ZEDDftONY1F0oT43nLgIfJoYm+Fa6Gny5jJFONvR
-K6PnszkCgYEA3YcOE70I+q0v4pLWMEBls5CLneQty22XvG+6mK+svfxnxJ4ke6z7
-PVyvE/gOismIRIB1Vtn1lRNqXYfVULpatfIF0fpVa32ma+Lz5hq2RsJYdr/v2udj
-/sKXs/Fi5mXrqiHdV6RzT7enCAryrIUji0nsEg/2pW6F79atuez0UgcCgYEAxczL
-/TEkxSGSdxZpWN26JugEY99CTOzP0F95AA4PFEJ/DgK/xW+L5gXOIoncEYT5f7Qq
-DaJhqRd3D8YA539oIqwaKwNYAGzTW0NDwhdl5FdOAuHX1vRESiozn9x93lAxk0U7
-3bSEMm6SH6UID3O5d4Y97xKqCHAEJTY+d0eNzvsCgYBPWZgWQ+kaebykSPqF8Bs9
-1bHdDaXFr2zhp5fMJ2kV6Hp2+DqTPmQEF9XyrjDvT78K4oSlZo9MJdc8x3IGZ6ok
-cBvbmfLM/QYGsRWyP7E46VZsutW8sJOl5qgWYYmOg8WFfHnfcd2IGX2wKNPCLjKM
-Kx9vXN55ZXx+a4RxC8p8MwKBgQCnhyxilsPw3t1hVa8GIE2w9CP7vrU12ACvGJ2w
-KTgmTae04ykvfKl9uf78C81DXV/ABIT1pUmX4JLr3iUX7TXy39cOBTf8rC9bBZ6W
-/iBDhJpDIKshmSNZuWKeDC7jIwLKHAJ3ZZPt7u5+NNWd2MMF88HzAdjXaqBoMAg6
-GHWIDwKBgQCjqhvQ+U6JEyfv+YlxYRKbpxl8LwCnhJRgUHaaG2zPXedfY1ksTOwn
-9BhCglc+cx2lSHSVQglTW75Dwm2tVCbGEFz/OWb6pFoZQHBL9hop87G7MXQ7CKH/
-ePVcaJfkH8VIfknR3nM3lQBt4MxpqnNHwt7KVVZEuOZ7FeUnIG8tmw==
+MIIEpAIBAAKCAQEA2dfa810plm9cJ2YwG0rUdTVhMNXV6qgMkVCRX/79+5u/Yzar
+zexyiMRYFoKkC+t0JwgPZc/PaAGyVcItRo78i+ehVMawMcKKwTi6wWyumXC47GSl
+1Ek+xU08hAXdG3DASoqeMIgdHHwcrXkTP95oN8/8AInbl7SuA+V/13WH9pdj0I/V
+GTvO9QNCahPij2KG+Lar+RYZd0Ky7Wj2GlXoDqS6fOWplm5/3ZUTXWOyGuXzGohH
+LU4IekkcVlbPfrsasm1K8+HfflHvlKGyAlNuZa4sPysUCCw8R+YC7aVgf0x684q+
+8fV9fVrBlT4ZCW9vhXQh8yJgNPFh1gZEd7w1FwIDAQABAoIBAAdh7lSjCp7DhV78
+cpLqNUsHlRSfmpFKQqrGDTcwoBDf1VuaZbYj1jnWVZnlsYOJ5jTQbB0qLsA6ln2b
+iAdFHz/qiKgj16LIEgW8U2/sq/odPNceDhSkqtDq7isXO8gLSSj9i6DfbAUkG6Cx
+YrqeYe/KR6MJCP0aLW+KXovBuurbZI/3fviTSxW9FwP8DbVnucp8agUGZbaDBSIw
+yfGw6uuP567Tl8Bw81lB5yAPANvsZILn2AQoVQoJt5xyZjLb7GGOkghpppNFUGpl
+6TRO8ulWgvxdtbltQE5piCL+ittu9vf4ywA1ELZQpaM+/Rb79NT4WuPLj8BQOzDC
+BPosoKkCgYEA7Flv0uZYVrSBm5RXbPRGC8okLiDC5sHb2ZklxfjxUomi30OqdgPS
+IyJ0bk9Eyn6nym5qPW0R7jLgkPhv/NmR8y5ALlmkFcXXhzcJWELZAKeHWMaIWWGT
+niB5IiD5AKqrjP8V3hTNCi0tI5IzcI9nCsq/Q51YzdIIAGWr1PpM3bUCgYEA6/SG
+XqG90VjOj4sJmyD/TAPJLvRJM0ue6GeFN+m8kyizkHLUx+mrQWO6l7BlkhfkNAyN
+Rrmf5egdFlsE1QkyAIB+Te/rJT+x4rF4H2Y/KG+5SdxfoqkE/wOY2HCdaD9iEIqO
+ldPQZgOaFeXsTh0CiUa64NqEz9YP0g1u3h7ZZxsCgYEAlH3QgumTwM3hzDSUBPEn
+/QpAVvbgXQiZLwpIMCyquZedy7YAp+rYoJhqHFATQUH3+3gJqZQYOtaePpbIDU1I
+pEd/rV9GdyN4uQw8A8bj/cRDheQeEEH889ElKesbZm7UH164h3H8LJObk4isZuDB
+9YbSShHWlGGMA2vdXI7xsi0CgYEAhUfjWrLsAMO0MhrseycBblO5IX+1lXcCtO48
+rt+luE5GV7K1hJL2PIJz1Nk8FnDOY6QvbSLPMlORkp4pNZjzGJt8PNPntGutNIrg
+eoQL6vBo7lK/5qaofs/uV1wNXeRnpUZO0k0KK4WfVP1CJMF4PEiqqPZmDOwylYkm
+9erhDL8CgYBL+DOZVINGWebvCFPQE6EqgsdF0IiQQdPm6o7gfFlv+wECohMvmXHM
+GN4kpBSO4d9qgwd6HSYQ3MfN2xaTPTEEboxt9SBQ9GIO+IXhNBX9dU7/GDpFu2Hd
+sQsLSPlzvNeO5yYV2iWO4Buz85A3CKfHIJTwPO75WaBlyFP3ajjGtA==
 -----END RSA PRIVATE KEY-----
Index: examples/evaluator_rt1_typed/rr
===================================================================
--- examples/evaluator_rt1_typed/rr	(revision a5e8390270ff23c2fbb7566e5bf9eb66f83e75e5)
+++ examples/evaluator_rt1_typed/rr	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,2 +1,4 @@
+
+rm -rf creds_dump
 
 eloc=/home/mei/Deter/abac/libabac
@@ -8,12 +10,25 @@
 john=`creddy --keyid --cert John_ID.pem`
 
+usc_employee="[keyid:$usc].role:employee"
+usc_eval_maryann="[keyid:$usc].role:evaluatorOf([keyid:$maryann])"
+isi_manager_maryann="[keyid:$isi].role:managerOf([keyid:$maryann])"
+john_prin="[keyid:$john]"
 
-#USC.evaluatorOf(Maryann) <-?- John yap
+## dump all credentials
+$eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
+
+#[keyid:USC].role:evaluatorOf([keyid:Maryann]) <-?- [keyid:John] yap
 echo "===good============ USC.evaluatorOf(Maryann) <- John yap "
-$eloc/abac_prover_yap  --keystore $keyloc --role '$usc.evaluatorOf($maryann)' --principal $john
+$eloc/abac_prover_yap  --keystore $keyloc --role "$usc_eval_maryann" --principal "$john_prin"
 
-#USC.employee <-?- John yap
-#echo "===good============ USC.employee <- John yap "
-#$eloc/abac_prover_yap  --keystore $keyloc --role $usc.employee --principal $john
+#[keyid:ISI].role:managerOf([keyid:Maryann]) <-?- [keyid:John] yap
+echo "===good============ USC.evaluatorOf(Maryann) <- John yap "
+$eloc/abac_prover_yap  --keystore $keyloc --role "$isi_manager_maryann" --principal "$john_prin"
 
 
+#[keyid:USC].role:employee <- [keyid:John] yap "
+#USC.employee <-?- John yap
+echo "===good============  USC.employee <-?- John yap  "
+$eloc/abac_prover_yap  --keystore $keyloc --role "$usc_employee" --principal "$john_prin"
+
+
